#ifndef ARCH_GENERIC_H_
#define ARCH_GENERIC_H_

struct quad;

struct quads_ctx {
	struct quad **quads;
	unsigned int size;
	unsigned int cur;
};

struct q_vfuncs {
	void (*q_label)(struct quad *, struct quads_ctx *);
	void (*q_goto)(struct quad *, struct quads_ctx *);
	void (*q_if)(struct quad *, struct quads_ctx *);
	void (*q_call)(struct quad *, struct quads_ctx *);
	void (*q_param)(struct quad *, struct quads_ctx *);
	void (*q_op)(struct quad *, struct quads_ctx *);
	void (*q_assign)(struct quad *, struct quads_ctx *);
	void (*q_store_access)(struct quad *, struct quads_ctx *);
	void (*q_load_access)(struct quad *, struct quads_ctx *);
#ifdef _MEM_AREA
	void (*q_store_mem_area)(struct quad *, struct quads_ctx *);
	void (*q_load_mem_area)(struct quad *, struct quads_ctx *);
#endif
	void (*q_func)(struct quad *, struct quads_ctx *);
	void (*q_scope)(struct quad *, struct quads_ctx *);
	void (*q_scope_end)(struct quad *, struct quads_ctx *);
	void (*q_func_end)(struct quad *, struct quads_ctx *);
};

typedef void  (*code_print_out_t)(const char *fmt, ...);

extern code_print_out_t arch_print_out;

struct q_vfuncs *machine_get_vfuncs();
void machine_set_vfuncs(struct q_vfuncs *funcs);
void machine_gen_code(struct quad **quads, unsigned int quads_size, code_print_out_t func);

#endif /* ARCH_GENERIC_H_ */

